Index: uspace/app/hbench/ipc/read1k.c
===================================================================
--- uspace/app/hbench/ipc/read1k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/hbench/ipc/read1k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,102 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <stdio.h>
+#include <ipc_test.h>
+#include <async.h>
+#include <errno.h>
+#include <str_error.h>
+#include "../hbench.h"
+
+enum {
+	rw_buf_size = 1024
+};
+
+static ipc_test_t *test = NULL;
+static uint8_t rw_buf[rw_buf_size];
+
+static bool setup(bench_env_t *env, bench_run_t *run)
+{
+	errno_t rc;
+
+	rc = ipc_test_create(&test);
+	if (rc != EOK) {
+		return bench_run_fail(run,
+		    "failed contacting IPC test server (have you run /srv/test/ipc-test?): %s (%d)",
+		    str_error(rc), rc);
+	}
+
+	rc = ipc_test_set_rw_buf_size(test, rw_buf_size);
+	if (rc != EOK) {
+		return bench_run_fail(run,
+		    "failed setting read/write buffer size.");
+	}
+
+	return true;
+}
+
+static bool teardown(bench_env_t *env, bench_run_t *run)
+{
+	ipc_test_destroy(test);
+	return true;
+}
+
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t niter)
+{
+	errno_t rc;
+
+	bench_run_start(run);
+
+	for (uint64_t count = 0; count < niter; count++) {
+		rc = ipc_test_read(test, rw_buf, rw_buf_size);
+
+		if (rc != EOK) {
+			return bench_run_fail(run, "failed reading buffer: %s (%d)",
+			    str_error(rc), rc);
+		}
+	}
+
+	bench_run_stop(run);
+
+	return true;
+}
+
+benchmark_t benchmark_read1k = {
+	.name = "read1k",
+	.desc = "IPC read 1kB buffer benchmark",
+	.entry = &runner,
+	.setup = &setup,
+	.teardown = &teardown
+};
+
+/** @}
+ */
Index: uspace/app/hbench/ipc/write1k.c
===================================================================
--- uspace/app/hbench/ipc/write1k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/hbench/ipc/write1k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,102 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <stdio.h>
+#include <ipc_test.h>
+#include <async.h>
+#include <errno.h>
+#include <str_error.h>
+#include "../hbench.h"
+
+enum {
+	rw_buf_size = 1024
+};
+
+static ipc_test_t *test = NULL;
+static uint8_t rw_buf[rw_buf_size];
+
+static bool setup(bench_env_t *env, bench_run_t *run)
+{
+	errno_t rc;
+
+	rc = ipc_test_create(&test);
+	if (rc != EOK) {
+		return bench_run_fail(run,
+		    "failed contacting IPC test server (have you run /srv/test/ipc-test?): %s (%d)",
+		    str_error(rc), rc);
+	}
+
+	rc = ipc_test_set_rw_buf_size(test, rw_buf_size);
+	if (rc != EOK) {
+		return bench_run_fail(run,
+		    "failed setting read/write buffer size.");
+	}
+
+	return true;
+}
+
+static bool teardown(bench_env_t *env, bench_run_t *run)
+{
+	ipc_test_destroy(test);
+	return true;
+}
+
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t niter)
+{
+	errno_t rc;
+
+	bench_run_start(run);
+
+	for (uint64_t count = 0; count < niter; count++) {
+		rc = ipc_test_write(test, rw_buf, rw_buf_size);
+
+		if (rc != EOK) {
+			return bench_run_fail(run, "failed writing buffer: %s (%d)",
+			    str_error(rc), rc);
+		}
+	}
+
+	bench_run_stop(run);
+
+	return true;
+}
+
+benchmark_t benchmark_write1k = {
+	.name = "write1k",
+	.desc = "IPC write 1kB buffer benchmark",
+	.entry = &runner,
+	.setup = &setup,
+	.teardown = &teardown
+};
+
+/** @}
+ */
Index: uspace/app/hbench/meson.build
===================================================================
--- uspace/app/hbench/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hbench/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2018 Jiri Svoboda
+# Copyright (c) 2024 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'math' ]
+deps = [ 'block', 'math', 'ipctest' ]
 src = files(
 	'benchlist.c',
@@ -34,10 +34,15 @@
 	'main.c',
 	'utils.c',
+	'disk/randread.c',
+	'disk/seqread.c',
 	'fs/dirread.c',
 	'fs/fileread.c',
 	'ipc/ns_ping.c',
 	'ipc/ping_pong.c',
+	'ipc/read1k.c',
+	'ipc/write1k.c',
 	'malloc/malloc1.c',
 	'malloc/malloc2.c',
 	'synch/fibril_mutex.c',
+	'syscall/taskgetid.c'
 )
Index: uspace/app/hbench/syscall/taskgetid.c
===================================================================
--- uspace/app/hbench/syscall/taskgetid.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/hbench/syscall/taskgetid.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,74 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <stdio.h>
+#include <errno.h>
+#include <str_error.h>
+#include <task.h>
+#include "../hbench.h"
+
+static volatile task_id_t tid;
+
+static bool setup(bench_env_t *env, bench_run_t *run)
+{
+	return true;
+}
+
+static bool teardown(bench_env_t *env, bench_run_t *run)
+{
+	return true;
+}
+
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t niter)
+{
+	bench_run_start(run);
+
+	for (uint64_t count = 0; count < niter; count++) {
+		tid = task_get_id();
+		(void)tid;
+	}
+
+	bench_run_stop(run);
+
+	return true;
+}
+
+benchmark_t benchmark_taskgetid = {
+	.name = "taskgetid",
+	.desc = "task_get_id system call benchmark",
+	.entry = &runner,
+	.setup = &setup,
+	.teardown = &teardown
+};
+
+/** @}
+ */
Index: uspace/app/hello/hello.c
===================================================================
--- uspace/app/hello/hello.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/hello/hello.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -152,5 +152,5 @@
 int main(int argc, char *argv[])
 {
-	const char *display_spec = UI_DISPLAY_DEFAULT;
+	const char *display_spec = UI_ANY_DEFAULT;
 	errno_t rc;
 	int i;
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/init/init.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -476,6 +476,5 @@
 		rc = display_server();
 		if (rc == EOK) {
-			app_start("/app/launcher", NULL);
-			app_start("/app/barber", NULL);
+			app_start("/app/taskbar", NULL);
 			app_start("/app/terminal", "-topleft");
 		}
Index: uspace/app/init/untar.c
===================================================================
--- uspace/app/init/untar.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/init/untar.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2018 Martin Decky
  * All rights reserved.
@@ -59,5 +60,5 @@
 		return ret;
 
-	ret = block_init(state->sid, 4096);
+	ret = block_init(state->sid);
 	if (ret != EOK)
 		return ret;
Index: uspace/app/meson.build
===================================================================
--- uspace/app/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,4 +28,5 @@
 
 apps = [
+	'aboutos',
 	'barber',
 	'bdsh',
@@ -39,4 +40,6 @@
 	'devctl',
 	'df',
+	'disp',
+	'display-cfg',
 	'dnscfg',
 	'dnsres',
@@ -55,5 +58,4 @@
 	'killall',
 	'kio',
-	'launcher',
 	'loc',
 	'logset',
@@ -66,7 +68,9 @@
 	'mkmfs',
 	'modplay',
+	'nav',
 	'netecho',
 	'nic',
 	'nterm',
+	'ofw',
 	'pci',
 	'ping',
@@ -78,4 +82,6 @@
 	'sysinfo',
 	'sysinst',
+	'taskbar',
+	'taskbar-cfg',
 	'taskdump',
 	'terminal',
Index: uspace/app/mkbd/meson.build
===================================================================
--- uspace/app/mkbd/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/mkbd/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'usb', 'usbdev', 'usbhid', 'drv' ]
+deps = [ 'usb', 'usbdev', 'usbhid', 'drv', 'console' ]
 src = files('main.c')
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/mkexfat/mkexfat.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2012 Maurizio Lombardi
  * All rights reserved.
@@ -858,5 +859,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK) {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/mkfat/mkfat.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,5 +66,6 @@
 	default_fat_count		= 2,
 	default_reserved_clusters	= 2,
-	default_media_descriptor	= 0xF8 /**< fixed disk */
+	default_media_descriptor	= 0xF8 /**< fixed disk */,
+	fat32_root_cluster		= 2
 };
 
@@ -198,5 +199,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
@@ -313,5 +314,5 @@
 	cfg->reserved_sectors = 1 + cfg->addt_res_sectors;
 
-	/* Only correct for FAT12/16 (FAT32 has root dir stored in clusters */
+	/* Only correct for FAT12/16 (FAT32 has root dir stored in clusters) */
 	rd_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
 	    cfg->sector_size);
@@ -434,4 +435,9 @@
 	}
 
+	if (cfg->fat_type == FAT32) {
+		/* Root dir is stored in cluster fat32_root_cluster */
+		addr += fat32_root_cluster * cfg->sectors_per_cluster;
+	}
+
 	/* Root directory */
 	printf("Writing root directory.\n");
@@ -529,5 +535,5 @@
 		bs->fat32.ebs = 0x29;
 		bs->fat32.id = host2uint32_t_be(vsn);
-		bs->fat32.root_cluster = 2;
+		bs->fat32.root_cluster = fat32_root_cluster;
 
 		(void) fat_label_encode(&bs->fat32.label, bs_label);
Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/mkmfs/mkmfs.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Maurizio Lombardi
  * All rights reserved.
@@ -211,5 +212,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/modplay/meson.build
===================================================================
--- uspace/app/modplay/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/modplay/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'trackmod', 'hound', 'pcm' ]
+deps = [ 'trackmod', 'hound', 'pcm', 'console' ]
 src = files('modplay.c')
 
Index: uspace/app/nav/doc/doxygroups.h
===================================================================
--- uspace/app/nav/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup nav nav
+ * @brief Navigator
+ * @ingroup apps
+ */
Index: uspace/app/nav/main.c
===================================================================
--- uspace/app/nav/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/** @file Navigator main.
+ *
+ * HelenOS file manager.
+ */
+
+#include <stdio.h>
+#include <str.h>
+#include <ui/ui.h>
+#include "nav.h"
+
+static void print_syntax(void)
+{
+	printf("Syntax: nav [-d <display-spec>]\n");
+}
+
+int main(int argc, char *argv[])
+{
+	const char *display_spec = UI_CONSOLE_DEFAULT;
+	errno_t rc;
+	int i;
+
+	i = 1;
+	while (i < argc && argv[i][0] == '-') {
+		if (str_cmp(argv[i], "-d") == 0) {
+			++i;
+			if (i >= argc) {
+				printf("Argument missing.\n");
+				print_syntax();
+				return 1;
+			}
+
+			display_spec = argv[i++];
+		} else {
+			printf("Invalid option '%s'.\n", argv[i]);
+			print_syntax();
+			return 1;
+		}
+	}
+
+	if (i < argc) {
+		print_syntax();
+		return 1;
+	}
+
+	rc = navigator_run(display_spec);
+	if (rc != EOK)
+		return 1;
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/nav/menu.c
===================================================================
--- uspace/app/nav/menu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/menu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,170 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/** @file Navigator.
+ *
+ * HelenOS file manager.
+ */
+
+#include <errno.h>
+#include <stdlib.h>
+#include <ui/menu.h>
+#include <ui/menubar.h>
+#include <ui/menudd.h>
+#include <ui/menuentry.h>
+#include "menu.h"
+#include "nav.h"
+
+/** Create navigator menu.
+ *
+ * @param window Navigator window
+ * @param rmenu Place to store pointer to new menu
+ * @return EOK on success or an error code
+ */
+errno_t nav_menu_create(ui_window_t *window, nav_menu_t **rmenu)
+{
+	nav_menu_t *menu;
+	ui_menu_t *mfile;
+	ui_menu_entry_t *mopen;
+	ui_menu_entry_t *mfsep;
+	ui_menu_entry_t *mexit;
+	gfx_rect_t arect;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	menu = calloc(1, sizeof(nav_menu_t));
+	if (menu == NULL)
+		return ENOMEM;
+
+	menu->window = window;
+	menu->ui = ui_window_get_ui(window);
+
+	rc = ui_menu_bar_create(menu->ui, menu->window,
+	    &menu->menubar);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_menu_dd_create(menu->menubar, "~F~ile", NULL, &mfile);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_menu_entry_create(mfile, "~O~pen", "Enter", &mopen);
+	if (rc != EOK)
+		goto error;
+
+	ui_menu_entry_set_cb(mopen, nav_menu_file_open, (void *) menu);
+
+	rc = ui_menu_entry_sep_create(mfile, &mfsep);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_menu_entry_create(mfile, "E~x~it", "Ctrl-Q", &mexit);
+	if (rc != EOK)
+		goto error;
+
+	ui_menu_entry_set_cb(mexit, nav_menu_file_exit, (void *) menu);
+
+	ui_window_get_app_rect(menu->window, &arect);
+
+	rect.p0 = arect.p0;
+	rect.p1.x = arect.p1.x;
+	rect.p1.y = arect.p0.y + 1;
+	ui_menu_bar_set_rect(menu->menubar, &rect);
+
+	*rmenu = menu;
+	return EOK;
+error:
+	nav_menu_destroy(menu);
+	return rc;
+}
+
+/** Set navigator menu callbacks.
+ *
+ * @param menu Menu
+ * @param cb Callbacks
+ * @param arg Argument to callback functions
+ */
+void nav_menu_set_cb(nav_menu_t *menu, nav_menu_cb_t *cb, void *arg)
+{
+	menu->cb = cb;
+	menu->cb_arg = arg;
+}
+
+/** Destroy navigator menu.
+ *
+ * @param menu Menu
+ */
+void nav_menu_destroy(nav_menu_t *menu)
+{
+	if (menu->menubar != NULL)
+		ui_menu_bar_destroy(menu->menubar);
+
+	free(menu);
+}
+
+/** Return base UI control for the menu bar.
+ *
+ * @param menu Navigator menu
+ * @return UI control
+ */
+ui_control_t *nav_menu_ctl(nav_menu_t *menu)
+{
+	return ui_menu_bar_ctl(menu->menubar);
+}
+
+/** File / Open menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (navigator_t *)
+ */
+void nav_menu_file_open(ui_menu_entry_t *mentry, void *arg)
+{
+	nav_menu_t *menu = (nav_menu_t *)arg;
+
+	if (menu->cb != NULL && menu->cb->file_open != NULL)
+		menu->cb->file_open(menu->cb_arg);
+}
+
+/** File / Exit menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (navigator_t *)
+ */
+void nav_menu_file_exit(ui_menu_entry_t *mentry, void *arg)
+{
+	nav_menu_t *menu = (nav_menu_t *)arg;
+
+	if (menu->cb != NULL && menu->cb->file_exit != NULL)
+		menu->cb->file_exit(menu->cb_arg);
+}
+
+/** @}
+ */
Index: uspace/app/nav/menu.h
===================================================================
--- uspace/app/nav/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator menu
+ */
+
+#ifndef MENU_H
+#define MENU_H
+
+#include <errno.h>
+#include <ui/menuentry.h>
+#include <ui/window.h>
+#include "types/menu.h"
+
+extern errno_t nav_menu_create(ui_window_t *, nav_menu_t **);
+extern void nav_menu_set_cb(nav_menu_t *, nav_menu_cb_t *, void *);
+extern void nav_menu_destroy(nav_menu_t *);
+extern ui_control_t *nav_menu_ctl(nav_menu_t *);
+extern void nav_menu_file_open(ui_menu_entry_t *, void *);
+extern void nav_menu_file_exit(ui_menu_entry_t *, void *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nav/meson.build
===================================================================
--- uspace/app/nav/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,45 @@
+#
+# Copyright (c) 2021 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+deps = [ 'ui' ]
+src = files(
+	'main.c',
+	'menu.c',
+	'nav.c',
+	'panel.c',
+)
+
+test_src = files(
+	'menu.c',
+	'nav.c',
+	'panel.c',
+	'test/main.c',
+	'test/menu.c',
+	'test/nav.c',
+	'test/panel.c',
+)
